###目录
* [一些书目](#一些书目)
* [GUI编程](#gui编程)
* [图形学相关](#图形学相关)
* [语言无关类](#语言无关类)
    * [算法和数据结构](#算法和数据结构)
    * [计算理论](#计算理论)
    * [操作系统](#操作系统)
    * [数据库](#数据库)
    * [网络](#网络)
    * [编译器设计](#编译器设计)
    * [编程范式](#编程范式)
    * [并行化编程](#并行化编程)
    * [软件架构](#软件架构)
    * [开源社区](#开源社区)
    * [信息检索](#信息检索)
    * [数据挖掘](#数据挖掘)
    * [机器学习](#机器学习)
    * [数学](#数学)
    * [其他](#其他)
    * [在线教育](#在线教育)
    * [专家级开发](#专家级开发)
* [Git](#git)
* [JavaScript](#javascript)

###一些书目
* [Cheat Sheets (Free)](http://refcardz.dzone.com/)
* [电子书目录](http://www.e-booksdirectory.com/)
* [Free Smalltalk Books，由Stéphane Ducasse收集](http://stephane.ducasse.free.fr/FreeBooks.html)
* [www.FreeTechBooks.com](http://www.freetechbooks.com/)
* [HackerShelf.com](http://hackershelf.com/browse/)
* [微软出版社：免费电子书](http://blogs.msdn.com/b/microsoft_press/archive/2011/03/03/ebooks-list-of-our-free-books.aspx)
* [维基书籍：编程](http://en.wikibooks.org/wiki/Category%3aComputer_programming)
* [JSBooks - 免费的JavaScript电子书目录](https://github.com/revolunet/JSbooks)


###图形学相关
* [DirectX manual -- 《DirectX手册》](http://www.xmission.com/~legalize/book/download/index.html) (draft)
* [Learning Modern 3D Graphics Programming -- 《学习现代3D图像编程》](http://www.arcsynthesis.org/gltut/) (draft)
* [Introduction to Modern OpenGL -- 《现代OpenGL导论》](http://open.gl/)
* [GPU Gems -- 《GPU宝石》](http://http.developer.nvidia.com/GPUGems/gpugems_part01.html)
* [GPU Gems 2 -- 《GPU宝石2》](http://http.developer.nvidia.com/GPUGems2/gpugems2_part01.html) - [ch 8,14,18,29,30 as pdf](ftp://download.nvidia.com/developer/GPU_Gems_2/)
* [GPU Gems 3 -- 《GPU宝石3》](http://http.developer.nvidia.com/GPUGems3/gpugems3_part01.html)
* [Graphics Programming Black Book -- 《图形编程黑皮书》](http://www.gamedev.net/page/resources/_/technical/graphics-programming-and-theory/graphics-programming-black-book-r1698)
* [OpenGL Insights -- 《OpenGL的见解》](http://openglinsights.com) (chapters 22, 23, 28, 33, 39)
* [ShaderX series -- 《ShaderX系列》](http://tog.acm.org/resources/shaderx/)
* [Tutorials for modern OpenGL -- 《现代OpenGL教程》](http://www.opengl-tutorial.org/)


###GUI编程
* [Programming with gtkmm 3 -- 《gtkmm3编程》](https://developer.gnome.org/gtkmm-tutorial/stable/)


###语言无关类

####算法和数据结构
* [Algorithms and Data-Structures -- 《算法和数据结构》](http://www.ethoberon.ethz.ch/WirthPubl/AD.pdf) (PDF)
* [Algorithms -- 《算法》](http://www.cs.berkeley.edu/~vazirani/algorithms.html) (draft)
* [Algorithms Course Materials -- 《算法教材》](http://compgeom.cs.uiuc.edu/~jeffe/teaching/algorithms/) - Jeff Erickson
* [Binary Trees -- 《二叉树》](http://cslibrary.stanford.edu/110/BinaryTrees.pdf) (PDF)
* [Clever Algorithms -- 《巧妙的算法》](http://www.cleveralgorithms.com/nature-inspired/index.html)
* [Computational Geometry: Algorithms and Applications -- 《计算几何：算法和应用》](http://www.cs.uu.nl/geobook/) (chapters 1 and 9, pseudo-code)
* [Data Structures and Algorithms: Annotated Reference with Examples -- 《数据结构与算法：带注释的参考例子》](http://dotnetslackers.com/projects/Data-Structures-And-Algorithms/)
* [The Algorithm Design Manual -- 《算法设计手册》](http://www8.cs.umu.se/kurser/TDBAfl/VT06/algorithms/BOOK/BOOK/BOOK.HTM)
* [Hacker's Delight -- 《黑客的乐趣》](http://www.hackersdelight.org) (chapter 2, code)
* [LEDA: A Platform for Combinatorial and Geometric Computing -- 《LEDA：组合和几何运算平台》](http://www.mpi-inf.mpg.de/~mehlhorn/LEDAbook.html)
* [Planning Algorithms -- 《规划算法》](http://planning.cs.uiuc.edu/)
* [Linked List Basics -- 《链表基础》](http://cslibrary.stanford.edu/103/LinkedListBasics.pdf) (PDF)
* [Linked List Problems -- 《链表问题》](http://cslibrary.stanford.edu/105/LinkedListProblems.pdf) (PDF)
* [Open Data Structures -- 《开放式数据结构》](http://opendatastructures.org/)
* [Purely Functional Data Structures -- 《纯粹的功能性数据结构》](http://www.cs.cmu.edu/~rwh/theses/okasaki.pdf) (PDF)
* [The Great Tree List Recursion Problem -- 《大规模树列表递归问题》](http://cslibrary.stanford.edu/109/TreeListRecursion.pdf) (PDF)
* [Matters Computational -- 《计算的事项》](http://www.jjj.de/fxt/#fxtbook)
* [Algorithmic Graph Theory -- 《图论算法》](http://code.google.com/p/graphbook/)
* [Foundations of Computer Science -- 《计算机科学基础》](http://infolab.stanford.edu/~ullman/focs.html) - Al Aho and Jeff Ullman
* [A Field Guide To Genetic Programming -- 《遗传编程的一个领域指南》](http://dces.essex.ac.uk/staff/rpoli/gp-field-guide/toc.html)
* [The Art of Computer Programming -- 《计算机程序设计艺术》](http://www.cs.utsa.edu/~wagner/knuth/) (fascicles, mostly volume 4)
* [Programming Pearls -- 《编程珠玑》](http://cs.bell-labs.com/cm/cs/pearls/)
* [Algorithms for Programmers: Ideas and Source Code -- 《程序员：思想和源代码的算法》](http://www.jjj.de/fxt/fxtbook.pdf) (PDF)
* [Sequential and parallel sorting algorithms -- 《顺序和并行排序算法》](http://www.inf.fh-flensburg.de/lang/algorithmen/sortieren/algoen.htm)
* [Text Algorithms -- 《文本算法》](http://igm.univ-mlv.fr/~mac/REC/text-algorithms.pdf) (PDF)
* [Problem Solving with Algorithms and Data Structures -- 《算法和数据结构问题解决》](http://interactivepython.org/courselib/static/pythonds/index.html)
* [Data Structures Succinctly Part 1, Syncfusion -- 《数据结构精讲》](http://www.syncfusion.com/resources/techportal/ebooks/datastructurespart1) (PDF, Kindle) *(Just fill the fields with any values)*
* [Data Structures Succinctly Part 2, Syncfusion -- 《数据结构精讲》](http://www.syncfusion.com/resources/techportal/ebooks/datastructurespart2) (PDF, Kindle) *(Just fill the fields with any values)*


####计算理论
* [Structure and Interpretation of Computer Programs -- 《计算机程序的构造和解释》](http://mitpress.mit.edu/sicp/)
* [Programming Languages: Application and Interpretation -- 《程序语言：应用及解释》](http://www.cs.brown.edu/~sk/Publications/Books/ProgLangs/)
* [Introduction to Computing -- 《计算概论》](http://www.computingbook.org/)
* [An Introduction to the Theory of Computation -- 《计算理论简介》](http://www.cse.ohio-state.edu/~gurari/theory-bk/theory-bk.html)
* [Think Complexity -- 《思想复杂性》](http://www.greenteapress.com/compmod/) - Allen B. Downey

####操作系统
* [The Art of Unix Programming -- 《Unix编程艺术》](http://catb.org/esr/writings/taoup/html/)
* [The Little Book of Semaphores -- 《信号灯的手册》](http://greenteapress.com/semaphores/) - Allen B. Downey
* [Operating Systems and Middleware -- 《操作系统和中间件》](https://gustavus.edu/mcs/max/os-book/) (PDF and LaTeX)
* [Practical File System Design:The Be File System -- 《实用的文件系统设计：BE文件系统》](http://www.nobius.org/~dbg/practical-file-system-design.pdf)(PDF) - Dominic Giampaolo

####数据库
* [Database-backed Web Sites -- 《数据库支持的Web站点》](http://philip.greenspun.com/wtr/dead-trees/)

####网络

####编译器设计
* [Compiler Design: Theory, Tools, and Examples -- 《编译器设计：理论，工具和范例》](http://elvis.rowan.edu/~bergmann/books.html)

####编程范式

####并行化编程

####软件架构

####开源社区
* [Data Journalism Handbook -- 《数据新闻手册》](http://datajournalismhandbook.org/)
* [Free Software, Free Society -- 《自由软件，自由社会》](http://shop.fsf.org/product/free-software-free-society-2/)
* [Getting started with Open source development -- 《开源开发入门》](http://public.dhe.ibm.com/software/dw/db2/express-c/wiki/Getting_started_with_open_source_development_p2.pdf) (PDF)
* [Innovation Happens Elsewhere -- 《创新在别处发生》](http://dreamsongs.com/IHE/IHE.html)
* [Producing Open Source Software -- 《构建开源软件》](http://producingoss.com/)
* [The Cathedral and the Bazaar -- 《大教堂和市集》](http://www.catb.org/esr/writings/cathedral-bazaar/)
* [The Architecture of Open Source Applications -- 《开源应用程序的体系结构》](http://www.aosabook.org/en/index.html)
* [The Future of the Internet -- 《互联网的未来》](http://futureoftheinternet.org/)
* [The Performance of Open Source Applications -- 《开源应用程序的性能》](http://aosabook.org/en/)

####信息检索
* [Introduction to Information Retrieval -- 《现代信息检索》](http://nlp.stanford.edu/IR-book/information-retrieval-book.html)

####数据挖掘
* [Data Mining and Analysis: Fundamental Concepts and Algorithms -- 《数据挖掘和分析：基本概念和算法》](http://www.dataminingbook.info/DokuWiki/doku.php) (Draft)
* [Mining of Massive Datasets -- 《海量数据集挖掘》](http://infolab.stanford.edu/~ullman/mmds.html)
* [The Elements of Statistical Learning -- 《统计学习的元素》](http://www-stat.stanford.edu/~tibs/ElemStatLearn/)

####机器学习
* [Programming Computer Vision with Python -- 《计算机视觉与Python编程》](http://programmingcomputervision.com/)
* [A Course in Machine Learning -- 《机器学习教程》](http://hackershelf.com/book/492/a-course-in-machine-learning/)
* [Computer Vision: Algorithms and Applications -- 《计算机视觉：算法和应用》](http://hackershelf.com/book/134/computer-vision-algorithms-and-applications/)
* [Bayesian Reasoning and Machine Learning -- 《贝叶斯推理和机器学习》](http://web4.cs.ucl.ac.uk/staff/D.Barber/pmwiki/pmwiki.php?n=Brml.HomePage)
* [Introduction to Machine Learning -- 《机器学习简介》](http://alex.smola.org/drafts/thebook.pdf) (PDF)
* [Gaussian Processes for Machine Learning -- 《高斯过程机器学习》](http://www.gaussianprocess.org/gpml/)
* [Information Theory, Inference, and Learning Algorithms -- 《信息理论，推理和学习算法》](http://www.inference.phy.cam.ac.uk/itila/)
* [Artificial Intelligence | Machine Learning -- 《人工智能|机器学习》](http://see.stanford.edu/see/materials/aimlcs229/handouts.aspx) - Andrew Ng *(Notes, lectures, and problems)*
* [Probabilistic Models in the Study of Language -- 《在语言研究中的概率模型》](http://idiom.ucsd.edu/~rlevy/pmsl_textbook/text.html) (Draft, with R code)

####数学
* [Think Bayes: Bayesian Statistics Made Simple -- 《学习贝叶斯：简单贝叶斯统计》](http://www.greenteapress.com/thinkbayes/) - Allen B. Downey
* [Think Stats: Probability and Statistics for Programmers -- 《学习统计：概率论与统计程序员》](http://greenteapress.com/thinkstats/) (code written in Python) - Allen B. Downey
* [Mathematical Logic - an Introduction -- 《数理逻辑 - 介绍》](http://www.ii.uib.no/~michal/und/i227/book/book.pdf) (PDF)
* [Bayesian Methods for Hackers -- 《黑客的贝叶斯方法》](https://github.com/CamDavidsonPilon/Probabilistic-Programming-and-Bayesian-Methods-for-Hackers)
* [Introduction to Statistical Thought -- 《统计思想概论》](http://www.math.umass.edu/~lavine/Book/book.html)
* [Mathematics for Computer Science -- 《计算机科学中的数学》](http://ocw.mit.edu/courses/electrical-engineering-and-computer-science/6-042j-mathematics-for-computer-science-fall-2010/readings/)
* [Category Theory for Computing Science -- 《分类理论计算科学》](http://www.math.mcgill.ca/triples/Barr-Wells-ctcs.pdf) (PDF)
* [Essentials of Metaheuristics -- 《元启发式要点》](http://cs.gmu.edu/~sean/book/metaheuristics/) by Sean Luke
* [Advanced Data Analysis from an Elementary Point of View -- 《从初级观点看先进的数据分析》](http://www.stat.cmu.edu/~cshalizi/ADAfaEPoV/)
* [Probability and Statistics Cookbook -- 《概率与统计参考书》](http://matthias.vallentin.net/probability-and-statistics-cookbook/)

####其他
* [97 Things Every Programmer Should Know -- 《每个程序员都应该知道的97件事》](http://programmer.97things.oreilly.com/)
* [97 Things Every Programmer Should Know - Extended -- 《每个程序员都应该知道的97件事-扩展》](https://leanpub.com/97-Things-Every-Programmer-Should-Know-Extended)
* [A Mathematical Theory of Communication -- 《通信的数学理论》](http://cm.bell-labs.com/cm/ms/what/shannonday/paper.html) by Claude E.Shannon
* [Asterisk™: The Definitive Guide -- 《Asterisk™：权威指南》](http://asteriskdocs.org/en/3rd_Edition/asterisk-book-html-chunk/index.html)
* [How to Think Like a Computer Scientist -- 《如何像计算机科学家那样思考》](http://openbookproject.net/thinkcs/)
* [I Am a Bug -- 《我是一个Bug》](http://www.amibug.com/iamabug/p01.html)
* [Learn to Program -- 《学习编程》](http://pine.fm/LearnToProgram/)
* [Foundations of Programming -- 《编程基础》](http://codebetter.com/files/folders/codebetter_downloads/entry179694.aspx)
* [Communicating Sequential Processes -- 《通信顺序进程》](http://www.usingcsp.com/cspbook.pdf) (PDF) by Tony Hoare
* [Come, Let's Play: Scenario-Based Programming Using Live Sequence Charts -- 《来吧，让我们玩：基于场景的编程使用即时序列图》](http://www.scribd.com/doc/175241338/Come-Let-s-Play)
* [Computer Musings -- 《计算机沉思录》](http://scpd.stanford.edu/knuth/index.jsp) (lectures by Donald Knuth)
* [How Computers Work -- 《计算机工作原理》](http://www.fastchip.net/howcomputerswork/p1.html)
* [Data-Intensive Text Processing with MapReduce -- 《MapReduce的数据密集型的文字处理》](http://www.umiacs.umd.edu/~jimmylin/MapReduce-book-final.pdf) (PDF)
* [Designing Interfaces -- 《接口设计》](http://designinginterfaces.com) by Jennifer Tidwell
* [Digital Signal Processing For Engineers and Scientists -- 《工程师和科学家的数字信号处理技术》](http://www.dspguide.com/)
* [Distributed systems for fun and profit -- 《分布式系统的乐趣和利润》](http://book.mixu.net/distsys/single-page.html)
* [Flow based Programming -- 《基于流的编程》](http://jpaulmorrison.com/fbp/#book)
* [Getting Real -- 《获得真理》](http://gettingreal.37signals.com/)
* [Magic Ink: Information Software and The Graphical Interface -- 《魔术的墨水：信息软件和图形界面》](http://worrydream.com/#!/MagicInk) by Bret Victor
* [Modeling Reactive Systems with Statecharts -- 《反应系统建模与状态图》](http://www.scribd.com/doc/167971960/Modeling-Reactive-Systems-With-Statecharts)
* [PNG: The Definitive Guide -- 《PNG：权威指南》](http://www.libpng.org/pub/png/book/)
* [Pointers And Memory -- 《指针和内存》](http://cslibrary.stanford.edu/102/PointersAndMemory.pdf) (PDF)
* [Project Oberon -- 《奥伯伦工程》](http://www-old.oberon.ethz.ch/WirthPubl/ProjectOberon.pdf) (PDF)
* [Security Engineering -- 《安全工程》](http://www.cl.cam.ac.uk/~rja14/book.html)
* [Small Memory Software -- 《小型存储软件》](http://www.smallmemory.com/book.html)
* [SVG Essentials -- 《SVG要点》](http://commons.oreilly.com/wiki/index.php/SVG_Essentials)
* [Introduction to High-Performance Scientific Computing -- 《高性能科学计算简介》](http://tacc-web.austin.utexas.edu/veijkhout/public_html/istc/istc.html) - Victor Eijkhout
* [Object-Oriented Reengineering Patterns -- 《面向对象的再造模式》](http://win.ua.ac.be/~sdemey/) - Serge Demeyer, Stéphane Ducasse and Oscar Nierstrasz
* [High-Performance Scientific Computing -- 《高性能科学计算》](http://bit.ly/hpc12) (class lectures and slides)
* [Mother Tongues of Computer Languages -- 《计算机语言的母语》](http://www.digibarn.com/collections/posters/tongues/) (PNG)

####在线教育
* [MIT OCW -- 麻省理工学院“开放式课程网页”](http://ocw.mit.edu/OcwWeb/web/home/home/index.htm)
* [Coursera](https://www.coursera.org/)
* [Udacity](https://www.udacity.com/)
* [edX](https://www.edx.org/)

####专家级开发

###Git
* [Pro Git](http://git-scm.com/book/zh)
* [Gitmagic](http://www-cs-students.stanford.edu/~blynn/gitmagic/intl/zh_cn/)

###Javascript
* [Javascript Garden](http://bonsaiden.github.io/JavaScript-Garden/zh/)
